#include <stdio.h>

// Question 1
int somme(int n)
{
  int res = 0;
  int i;
  for (i = 1; i <= n; i++)
  {
    res += i;
  }
  return res;
}

// Question 2
int somme_rec(int n)
{
  if (n == 0)
  {
    return 0;
  }
  else
  {
    return n + somme_rec(n-1);
  }
}

// Question 3
int factorielle(int n)
{
  int res = 1;
  int i;
  for (i = 2; i <= n; i++)
  {
    res *= i;
  }
  return res;
}

// Question 4
int factorielle_rec(int n)
{
  if (n == 0)
  {
    return 1;
  }
  else
  {
    return n * factorielle_rec(n-1);
  }
}

// Question 6
/* Déclaration du prototype des deux fonctions pair et impair */
int impair(int n);
int pair(int n);

int pair(int n)
{
  if (n == 0) 
  {
    return 1;
  }
  else if (n < 0)
  {
    return impair(n+1);
  }
  else 
  {
    return impair(n-1);
  }
}

int impair(int n)
{
  if (n == 0)
  {
    return 0;
  }
  else if (n < 0)
  {
    return pair(n+1);
  }
  else
  {
    return pair(n-1);
  }
}

// Question 7
int pgcd(int a, int b)
{
  if (b == 0)
  {
    return a;
  }
  else
  {
    return pgcd(b, a%b);
  }
}

// Question 8
int fibo_rec(int n)
{
  if (n == 0)
  {
    return 0;
  }
  else if (n == 1)
  {
    return 1;
  }
  else
  {
    return fibo_rec(n-1) + fibo_rec(n-2);
  }
}

// Question 9
int fibonacci_aux(int n, int a, int b)
{
  if (n == 0)
  {
    return a;
  }
  else if (n == 1)
  {
    return b;
  }
  else
  {
    return fibonacci_aux(n-1, b , a+b);
  }
}

int fibonacci2(int n)
{
  return fibonacci_aux(n, 0, 1);
}

/*** Fonction main ***/
int main()
{
  printf("%d\n", pgcd(12,27*2));
}
